%define anolis_release 3
%undefine _strict_symbol_defs_build
%global pa_major 16
%global pa_minor 1
%global bash_completionsdir %(pkg-config --variable=completionsdir bash-completion 2>/dev/null || echo '/etc/bash_completion.d')
%bcond_without webrtc
%bcond_without systemd
%bcond_without tests
%bcond_without gdm_hooks

Name:           pulseaudio
Version:        %{pa_major}.%{pa_minor}
Release:        %{anolis_release}%{?dist}
Summary:        Improved Linux Sound Server
License:        LGPLv2+
URL:            http://www.freedesktop.org/wiki/Software/PulseAudio
Source0:        http://freedesktop.org/software/%{name}/releases/%{name}-%{version}.tar.xz
Source1:        http://freedesktop.org/software/%{name}/releases/%{name}-%{version}.tar.xz.sha256sum

Source2:        default.pa-for-gdm

Patch1:         fix-volume-level-scroll-bar-cannot-be-selected.patch

BuildRequires:  meson >= 0.50.0 gcc g++ intltool doxygen xmltoman
BuildRequires:  pkgconfig(bash-completion) pkgconfig(bluez) >= 5.0 pkgconfig(speexdsp) >= 1.2
BuildRequires:  pkgconfig(gstreamer-1.0) >= 1.16.0 pkgconfig(gstreamer-app-1.0) >= 1.16.0 pkgconfig(gstreamer-rtp-1.0) >= 1.16.0
BuildRequires:  libtool-ltdl-devel libsndfile-devel libsndfile-devel alsa-lib-devel glib2-devel gtk2-devel avahi-devel
BuildRequires:  libatomic_ops-static, libatomic_ops-devel
BuildRequires:  sbc-devel xcb-util-devel xorg-x11-proto-devel openssl-devel orc-devel
BuildRequires:  libXtst-devel libXt-devel libXi-devel libSM-devel libX11-devel libICE-devel libtdb-devel libasyncns-devel
%if %{with systemd}
BuildRequires:  systemd-devel >= 184 systemd
%{?systemd_requires}
%endif
BuildRequires:  dbus-devel libcap-devel pkgconfig(fftw3f)
%if %{with webrtc}
BuildRequires:  pkgconfig(webrtc-audio-processing) >= 0.2
%endif
%if %{with tests}
BuildRequires:  pkgconfig(check)
%endif

# retired along with -libs-zeroconf, add Obsoletes here for lack of anything better
Obsoletes:      padevchooser < 1.0
Requires(pre):  shadow-utils
Requires:       %{name}-libs = %{version}-%{release} rtkit

# Virtual Provides to support swapping between PipeWire-PA and PA
Provides:       %{name}-daemon
Conflicts:      %{name}-daemon
Obsoletes:      %{name}-esound-compat < 15.0 %{name}-module-gconf < 15.0

%description
PulseAudio is a sound server system for POSIX OSes, meaning that it is a
proxy for your sound applications. It is an integral part of all relevant
modern Linux distributions and is used in various mobile devices, by
multiple vendors. It performs advanced operations on sound data as it
passes between your application and hardware.

%package libs
Summary:        Libraries for PulseAudio clients
License:        LGPLv2+
Obsoletes:      %{name}-libs-zeroconf < 1.1

%description libs
This package contains the runtime libraries for any application that wishes
to interface with a PulseAudio sound server.

%package libs-glib2
Summary:        GLIB 2.x bindings for PulseAudio clients
License:        LGPLv2+
Requires:       %{name}-libs = %{version}-%{release}

%description libs-glib2
This package contains bindings to integrate the PulseAudio client library with
a GLIB 2.x based application.

%package libs-devel
Summary:        Headers and libraries for PulseAudio client development
License:        LGPLv2+
Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-libs-glib2 = %{version}-%{release}

%description libs-devel
Headers and libraries for developing applications that can communicate with
a PulseAudio sound server.

%if %{with gdm_hooks}
%package gdm-hooks
Summary:        PulseAudio GDM integration
License:        LGPLv2+
Requires:       gdm >= 1:2.22.0
# for the gdm user
Requires(pre):  gdm

%description gdm-hooks
This package contains GDM integration hooks for the PulseAudio sound server.
%endif

%package qpaeq
Summary:	Pulseaudio equalizer interface
Requires: 	%{name} = %{version}-%{release}
Requires:	python3-qt5-base
Requires:	python3-dbus
%description qpaeq
qpaeq is a equalizer interface for %{name}'s equalizer sinks.

%package module-bluetooth
Summary:        Bluetooth support for the PulseAudio sound server
Requires:       %{name} = %{version}-%{release}
Requires:       bluez >= 5.0

%description module-bluetooth
Contains Bluetooth audio (A2DP/HSP/HFP) support for the PulseAudio sound server.

%package module-gsettings
Summary:        Gsettings support for the PulseAudio sound server
Requires:       %{name} = %{version}-%{release}

%description module-gsettings
GSettings configuration backend for the PulseAudio sound server.

%package module-x11
Summary:        X11 support for the PulseAudio sound server
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-utils

%description module-x11
X11 bell and security modules for the PulseAudio sound server.

%package module-zeroconf
Summary:        Zeroconf support for the PulseAudio sound server
Requires:       %{name} = %{version}-%{release}
Requires:       %{name}-utils

%description module-zeroconf
Zeroconf publishing module for the PulseAudio sound server.

%if 0%{?enable_jack}
%package module-jack
Summary:        JACK support for the PulseAudio sound server
BuildRequires:  jack-audio-connection-kit-devel
Requires:       %{name} = %{version}-%{release}

%description module-jack
JACK sink and source modules for the PulseAudio sound server.
%endif

%if 0%{?enable_lirc}
%package module-lirc
Summary:        LIRC support for the PulseAudio sound server
BuildRequires:  lirc-devel
Requires:       %{name} = %{version}-%{release}

%description module-lirc
LIRC volume control module for the PulseAudio sound server.
%endif

%package utils
Summary:        PulseAudio sound server utilities
License:        LGPLv2+
Requires:       %{name}-libs = %{version}-%{release}
Obsoletes:      %{name}-utils < 3.0

%description utils
This package contains command line utilities for the PulseAudio sound server.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup  -p1 -T -b0 -n %{name}-%{version}

sed -i.no_consolekit -e \
  's/^load-module module-console-kit/#load-module module-console-kit/' \
  src/daemon/default.pa.in

%build
%meson \
  -D system_user=pulse \
  -D system_group=pulse \
  -D access_group=pulse-access \
  -D oss-output=disabled \
  -D tcpwrap=disabled \
  -D bluez5=enabled \
  -D gstreamer=enabled \
  -D bluez5-gstreamer=enabled \
  -D gsettings=enabled \
  -D elogind=disabled \
  -D valgrind=disabled \
  -D gtk=disabled \
  -D soxr=disabled \
  -D jack=%{?enable_jack:enabled}%{!?enable_jack:disabled} \
  -D lirc=%{?enable_lirc:enabled}%{!?enable_lirc:disabled} \
%if %{with webrtc}
  -D webrtc-aec=enabled \
%else
  -D webrtc-aec=disabled \
%endif
%if %{with systemd}
  -D systemd=enabled \
%else
  -D systemd=disabled \
%endif
%if %{with tests}
  -D tests=true \
%else
  -D tests=false \
%endif

%meson_build

%meson_build doxygen

%install
%meson_install

mkdir -p $RPM_BUILD_ROOT%{_prefix}/lib/udev/rules.d
mv -fv $RPM_BUILD_ROOT/lib/udev/rules.d/90-%{name}.rules $RPM_BUILD_ROOT%{_prefix}/lib/udev/rules.d

%if %{with gdm_hooks}
install -p -m644 -D %{SOURCE2} $RPM_BUILD_ROOT%{_localstatedir}/lib/gdm/.pulse/default.pa
%endif

%find_lang %{name}

%check
%if %{with tests}
%meson_test || TESTS_ERROR=$?
if [ "${TESTS_ERROR}" != "" ]; then
cat src/test-suite.log
%{!?tests_nonfatal:exit $TESTS_ERROR}
fi
%endif

%pre
getent group pulse-access >/dev/null || groupadd -r pulse-access
getent group pulse-rt >/dev/null || groupadd -r pulse-rt
getent group pulse >/dev/null || groupadd -f -g 171 -r pulse
if ! getent passwd pulse >/dev/null ; then
    if ! getent passwd 171 >/dev/null ; then
      useradd -r -u 171 -g pulse -d %{_localstatedir}/run/pulse -s /sbin/nologin -c "PulseAudio System Daemon" pulse
    else
      useradd -r -g pulse -d %{_localstatedir}/run/pulse -s /sbin/nologin -c "PulseAudio System Daemon" pulse
    fi
fi
exit 0

%posttrans
# handle renamed module-cork-music-on-phone => module-role-cork
(grep '^load-module module-cork-music-on-phone$' %{_sysconfdir}/pulse/default.pa > /dev/null && \
 sed -i.rpmsave -e 's|^load-module module-cork-music-on-phone$|load-module module-role-cork|' \
 %{_sysconfdir}/pulse/default.pa
) ||:

%post
%if %{with systemd}
%systemd_user_post %{name}.service
%systemd_user_post %{name}.socket

%preun
%systemd_user_preun %{name}.service
%systemd_user_preun %{name}.socket

%triggerun -- %{name} < 12.2-4
# The %%post scriptlet above only does anything on initial package installation.
systemctl --no-reload preset --global %{name}.socket >/dev/null 2>&1 || :
%endif

%files
%license GPL LGPL LICENSE
%config(noreplace) %{_sysconfdir}/pulse/daemon.conf
%config(noreplace) %{_sysconfdir}/pulse/default.pa
%config(noreplace) %{_sysconfdir}/pulse/system.pa
%{_sysconfdir}/dbus-1/system.d/%{name}-system.conf
%{bash_completionsdir}/%{name}
%if %{with systemd}
%{_userunitdir}/%{name}.service
%{_userunitdir}/%{name}.socket
%endif
%{_bindir}/pa-info
%{_bindir}/%{name}
%{_libdir}/%{name}/libpulsecore-%{version}.so
%dir %{_libdir}/%{name}/
%dir %{_libdir}/%{name}/modules/
%{_libdir}/%{name}/modules/libalsa-util.so
%{_libdir}/%{name}/modules/libcli.so
%{_libdir}/%{name}/modules/libprotocol-cli.so
%{_libdir}/%{name}/modules/libprotocol-http.so
%{_libdir}/%{name}/modules/libprotocol-native.so
%{_libdir}/%{name}/modules/libprotocol-simple.so
%{_libdir}/%{name}/modules/librtp.so
%if %{with webrtc}
%{_libdir}/%{name}/modules/libwebrtc-util.so
%endif
%{_libdir}/%{name}/modules/module-allow-passthrough.so
%{_libdir}/%{name}/modules/module-alsa-sink.so
%{_libdir}/%{name}/modules/module-alsa-source.so
%{_libdir}/%{name}/modules/module-alsa-card.so
%{_libdir}/%{name}/modules/module-always-sink.so
%{_libdir}/%{name}/modules/module-always-source.so
%{_libdir}/%{name}/modules/module-augment-properties.so
%{_libdir}/%{name}/modules/module-cli-protocol-tcp.so
%{_libdir}/%{name}/modules/module-cli-protocol-unix.so
%{_libdir}/%{name}/modules/module-cli.so
%{_libdir}/%{name}/modules/module-combine.so
%{_libdir}/%{name}/modules/module-combine-sink.so
%{_libdir}/%{name}/modules/module-card-restore.so
%{_libdir}/%{name}/modules/module-console-kit.so
%{_libdir}/%{name}/modules/module-dbus-protocol.so
%{_libdir}/%{name}/modules/module-detect.so
%{_libdir}/%{name}/modules/module-default-device-restore.so
%{_libdir}/%{name}/modules/module-device-restore.so
%{_libdir}/%{name}/modules/module-device-manager.so
%{_libdir}/%{name}/modules/module-echo-cancel.so
%{_libdir}/%{name}/modules/module-filter-apply.so
%{_libdir}/%{name}/modules/module-filter-heuristics.so
%{_libdir}/%{name}/modules/module-hal-detect.so
%{_libdir}/%{name}/modules/module-http-protocol-tcp.so
%{_libdir}/%{name}/modules/module-http-protocol-unix.so
%{_libdir}/%{name}/modules/module-intended-roles.so
%{_libdir}/%{name}/modules/module-loopback.so
%{_libdir}/%{name}/modules/module-ladspa-sink.so
%{_libdir}/%{name}/modules/module-match.so
%{_libdir}/%{name}/modules/module-mmkbd-evdev.so
%{_libdir}/%{name}/modules/module-native-protocol-fd.so
%{_libdir}/%{name}/modules/module-native-protocol-tcp.so
%{_libdir}/%{name}/modules/module-native-protocol-unix.so
%{_libdir}/%{name}/modules/module-null-sink.so
%{_libdir}/%{name}/modules/module-null-source.so
%{_libdir}/%{name}/modules/module-pipe-sink.so
%{_libdir}/%{name}/modules/module-pipe-source.so
%{_libdir}/%{name}/modules/module-position-event-sounds.so
%{_libdir}/%{name}/modules/module-remap-source.so
%{_libdir}/%{name}/modules/module-rescue-streams.so
%{_libdir}/%{name}/modules/module-role-ducking.so
%{_libdir}/%{name}/modules/module-role-cork.so
%{_libdir}/%{name}/modules/module-rtp-recv.so
%{_libdir}/%{name}/modules/module-rtp-send.so
%{_libdir}/%{name}/modules/module-rygel-media-server.so
%{_libdir}/%{name}/modules/module-remap-sink.so
%{_libdir}/%{name}/modules/module-simple-protocol-tcp.so
%{_libdir}/%{name}/modules/module-simple-protocol-unix.so
%{_libdir}/%{name}/modules/module-sine.so
%{_libdir}/%{name}/modules/module-sine-source.so
%{_libdir}/%{name}/modules/module-switch-on-port-available.so
%{_libdir}/%{name}/modules/module-switch-on-connect.so
%{_libdir}/%{name}/modules/module-systemd-login.so
%{_libdir}/%{name}/modules/module-stream-restore.so
%{_libdir}/%{name}/modules/module-suspend-on-idle.so
%{_libdir}/%{name}/modules/module-tunnel-sink.so
%{_libdir}/%{name}/modules/module-tunnel-sink-new.so
%{_libdir}/%{name}/modules/module-tunnel-source-new.so
%{_libdir}/%{name}/modules/module-tunnel-source.so
%{_libdir}/%{name}/modules/module-udev-detect.so
%{_libdir}/%{name}/modules/module-volume-restore.so
%{_libdir}/%{name}/modules/module-virtual-sink.so
%{_libdir}/%{name}/modules/module-virtual-source.so
%{_libdir}/%{name}/modules/module-virtual-surround-sink.so
%dir %{_datadir}/%{name}/
%dir %{_datadir}/%{name}/alsa-mixer/
%{_datadir}/%{name}/alsa-mixer/paths/
%{_datadir}/%{name}/alsa-mixer/profile-sets/
%{_mandir}/man1/%{name}.1*
%{_mandir}/man5/default.pa.5*
%{_mandir}/man5/pulse-cli-syntax.5*
%{_mandir}/man5/pulse-client.conf.5*
%{_mandir}/man5/pulse-daemon.conf.5*
%{_prefix}/lib/udev/rules.d/90-%{name}.rules
%dir %{_libexecdir}/pulse
%dir %{_datadir}/zsh/
%dir %{_datadir}/zsh/site-functions/
%{_datadir}/zsh/site-functions/_%{name}

%files libs -f %{name}.lang
%license LICENSE GPL LGPL
%dir %{_sysconfdir}/pulse/
%config(noreplace) %{_sysconfdir}/pulse/client.conf
%{_libdir}/libpulse.so.0*
%{_libdir}/libpulse-simple.so.0*
%dir %{_libdir}/%{name}/
%{_libdir}/%{name}/libpulsecommon-%{version}.so

%files libs-glib2
%{_libdir}/libpulse-mainloop-glib.so.0*

%files libs-devel
%{_includedir}/pulse/
%{_libdir}/libpulse.so
%{_libdir}/libpulse-mainloop-glib.so
%{_libdir}/libpulse-simple.so
%{_libdir}/pkgconfig/libpulse*.pc
%dir %{_datadir}/vala
%dir %{_datadir}/vala/vapi
%{_datadir}/vala/vapi/libpulse.vapi
%{_datadir}/vala/vapi/libpulse.deps
%{_datadir}/vala/vapi/libpulse-mainloop-glib.vapi
%{_datadir}/vala/vapi/libpulse-mainloop-glib.deps
%{_datadir}/vala/vapi/libpulse-simple.deps
%{_datadir}/vala/vapi/libpulse-simple.vapi

%dir %{_libdir}/cmake
%{_libdir}/cmake/PulseAudio/

%if %{with gdm_hooks}
%files gdm-hooks
%attr(0700, gdm, gdm) %dir %{_localstatedir}/lib/gdm/.pulse
%attr(0600, gdm, gdm) %{_localstatedir}/lib/gdm/.pulse/default.pa
%endif

%files qpaeq
%{_bindir}/qpaeq
%{_libdir}/%{name}/modules/module-equalizer-sink.so

%files module-bluetooth
%{_libdir}/%{name}/modules/libbluez*-util.so
%{_libdir}/%{name}/modules/module-bluez*-device.so
%{_libdir}/%{name}/modules/module-bluez*-discover.so
%{_libdir}/%{name}/modules/module-bluetooth-discover.so
%{_libdir}/%{name}/modules/module-bluetooth-policy.so

%files module-gsettings
%{_libdir}/%{name}/modules/module-gsettings.so
%{_libexecdir}/pulse/gsettings-helper
%{_datadir}/GConf/gsettings/%{name}.convert
%{_datadir}/glib-2.0/schemas/org.freedesktop.%{name}.gschema.xml

%files module-x11
%config(noreplace) %{_sysconfdir}/xdg/autostart/%{name}.desktop
%config(noreplace) %{_sysconfdir}/xdg/Xwayland-session.d/00-%{name}-x11
%{_userunitdir}/%{name}-x11.service
%{_bindir}/start-%{name}-x11
%{_libdir}/%{name}/modules/module-x11-bell.so
%{_libdir}/%{name}/modules/module-x11-publish.so
%{_libdir}/%{name}/modules/module-x11-xsmp.so
%{_libdir}/%{name}/modules/module-x11-cork-request.so
%{_mandir}/man1/start-%{name}-x11.1*

%files module-zeroconf
%{_libdir}/%{name}/modules/libavahi-wrap.so
%{_libdir}/%{name}/modules/module-zeroconf-publish.so
%{_libdir}/%{name}/modules/module-zeroconf-discover.so
%{_libdir}/%{name}/modules/libraop.so
%{_libdir}/%{name}/modules/module-raop-discover.so
%{_libdir}/%{name}/modules/module-raop-sink.so

%if 0%{?enable_jack}
%files module-jack
%{_libdir}/%{name}/modules/module-jackdbus-detect.so
%{_libdir}/%{name}/modules/module-jack-sink.so
%{_libdir}/%{name}/modules/module-jack-source.so
%endif

%if 0%{?enable_lirc}
%files module-lirc
%{_libdir}/%{name}/modules/module-lirc.so
%endif

%files utils
%{_bindir}/pacat
%{_bindir}/pacmd
%{_bindir}/pactl
%{_bindir}/paplay
%{_bindir}/parec
%{_bindir}/pamon
%{_bindir}/parecord
%{_bindir}/pax11publish
%{_bindir}/pasuspender
%{_mandir}/man1/pacat.1*
%{_mandir}/man1/pacmd.1*
%{_mandir}/man1/pactl.1*
%{_mandir}/man1/pamon.1*
%{_mandir}/man1/paplay.1*
%{_mandir}/man1/parec.1*
%{_mandir}/man1/parecord.1*
%{_mandir}/man1/pasuspender.1*
%{_mandir}/man1/pax11publish.1*
%{bash_completionsdir}/pacat
%{bash_completionsdir}/pacmd
%{bash_completionsdir}/pactl
%{bash_completionsdir}/padsp
%{bash_completionsdir}/paplay
%{bash_completionsdir}/parec
%{bash_completionsdir}/parecord
%{bash_completionsdir}/pasuspender

%files doc
%doc %{_vpath_builddir}/doxygen/html README

%changelog
* Fri Dec 13 2024 yangxinyu <yangxinyu@nfschina.com> - 16.1-3
- add fix-volume-level-scroll-bar-cannot-be-selected.patch

* Wed Apr 12 2023 Jing Zhang <renyu.zj@linux.alibaba.com> - 16.1-2
- Refact spec

* Mon Dec 12 2022 Funda Wang <fundawang@yeah.net> - 16.1-1
- New version 16.1

* Tue Jul 26 2022 Chunmei Xu <xuchunmei@linux.alibaba.com> - 15.99.1-2
- provides libwebrtc-util.so

* Thu Apr 21 2022 zhang xianting <zhangxianting@uniontech.com> - 15.99.1-1
- Initial build for Anolis V23
